/*
 * semaphore.c
 *
 * use of POSIX semaphore
 * only minimal error handling !
 *
 * Bernhard Rabe
 * 22.11.2004
 *
 */
#include <semaphore.h>
#include <pthread.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>

/*semaphore*/
sem_t sem; 
 
/* Thread routine*/ 
void *run(void *data)
{
    do{
      if(-1==sem_trywait(&sem))
      {
	if(EAGAIN==errno)      
           printf("%d kein semaphore frei\n",pthread_self());
	else
        {
	  perror("sem_trywait");	
          exit(1);  
        }
        sleep(1);  
      }
      else
      {
          printf("%d semaphore erhalten\n",pthread_self());   
          sleep(3); 
          if(-1==sem_post(&sem))
          {
              perror("sem_post");
              exit(1);
          }
          printf("%d semaphore freigegeben\n",pthread_self());
          break;
      }
      
    }while(1);  
    pthread_exit((void*)0);
}


int main()
{
    int i;
    pthread_t pthread[10];
    /*concurrency of 2 threads*/
    if(-1==sem_init(&sem,0,2))
    {
        perror("sem_init");
        exit(1);
    }
    
    for(i=0;i<5;i++)
    {
        if(0!=pthread_create(&pthread[i],0,run,0))
        {
            fprintf(stderr,"pthread_create");
            exit(1);
        }
    }
    
    for (i=0; i < 5; i++)
    {
      int ret,*pret=&ret;
      
      if(0!=pthread_join(pthread[i],NULL))
      {
          fprintf(stderr,"pthread_join\n");
          exit(1);
      }
    }
    if(-1==sem_getvalue(&sem,&i))
    {
        perror("sem_getvalue");
        exit(1);
    }
    if(i==5)
    {
        if(-1==sem_destroy(&sem))
        {
            perror("sem_destroy");
            exit(1);
        }
    }   
    return 0;    
}
