/*
 * thread.c
 * POSIX Threads, detached/joinable mode, see makefile
 * only minimal error handling
 *
 * Bernhard Rabe
 * 22.11.2004
 *
 */

#include <pthread.h>
#include <stdio.h>
#include <errno.h>

/* -DDETACH -DATTR */

void *ThreadFunc(void *data)
{
    int retval=0; 
    int val=*(int*)data;
    printf("%d\n",val);
    /*gltigen Speicher im Hauptprogramm zurckgeben*/
    pthread_exit(data);
}

int main(int argc, char* argv[])
{
	pthread_t thread_id;
	int a=42,*b,c;
        pthread_attr_t attr;
        
	
        if(0!=pthread_attr_init(&attr))
	{
		printf("pthread_attr\n");
		exit(1);
	}
#ifdef ATTR	
	if(0!=pthread_attr_setdetachstate(&attr,PTHREAD_CREATE_DETACHED))
	{
		printf("attr\n");
		exit(1);
	}
#endif

	if(0!=pthread_attr_getdetachstate(&attr,&c))
	{
		printf("getdetach\n"); exit(1);
	}
	printf("%s\n",(c==PTHREAD_CREATE_DETACHED)?"detached":"joinable");
	if(0!=pthread_create(&thread_id,
				&attr
			  ,ThreadFunc,(void*)&a))
	{
		perror("pthread_create\n");
		exit(1);
	}
#ifdef DETACH
        
	switch(pthread_detach(thread_id))	
	{
           case ESRCH:
		    printf("No id\n"); exit(1); break;
	   case EINVAL:
		    printf("is already in detached mode\n"); break;
           case 0: 
		    break;
           default: 
		    printf("Unknow error"); exit(1);		      
		
	}
#endif 	
	if(0!=pthread_join(thread_id,(void**)&b))
	{
		printf("error pthread_join\n");
	}
	else
	{
	   printf("Retval=%d\n",*b);
	}   
	return 0;
}
